/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC12F1840
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include <stdio.h>
#include "mcc_generated_files/mcc.h"
#include "lcd_lib2.h"
#include "i2c_lib2.h"

// O[oϐ錾
unsigned long distance,count;

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);                         // t\Wo͊֐Ƃ
}

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // LCD
    lcd_init();                         // LCD

    // ZT[X^oC
    __delay_ms(500);                    // 0.5sec҂    
    
    while (1)
    {
        // Add your application code

        // ϐ    
        count = 0;
        distance = 0;            
      
        // Start PulseM
        TRISA4 = 0;                     // RA4(T1G)o̓[h    
            RA4 = 1;                    // RA4:High
            __delay_us(5);              // 5 usec
            RA4 = 0;                    // RA4:Low
        TRISA4 = 1;                     // RA4(T1G)̓[hɖ߂ 

        // Echo Time PulseM/ZLCD\
		while (!(RA4 = 1));             // GR[pXM҂̊ 
            TMR1 = 0;                   // TMR1WX^NA
       
		while (RA4 = 1);                // GR[pXM̊ 
        {
            count = TMR1;               // TMR1WX^ǂݏo

            lcd_cmd(0x80);              // LCD1s
            printf("Distance");         // ^Cg:Distance               
            
            if(count > 115 && count < 18500) {    // ͈͓̏	            
                distance = 0.0162 * count + 0.136;       // Z		

                lcd_cmd(0xC0);          // LCD2s
                printf("%lu cm    ", distance);     // l\            
            }            

            else {                        // ͈͊Ȍ                    
                lcd_cmd(0xC0);          // LCD2s                
                printf("N/A      ");      // N/A\                      
            }
        }
        __delay_ms(500);                // 0.5sec          
    }
}

/**
 End of File
*/